## org.mortbay.servlet
Class ConcatServlet

    java.lang.Object
      javax.servlet.GenericServlet
          javax.servlet.http.HttpServlet
              org.mortbay.servlet.ConcatServlet

All Implemented Interfaces:
  Serializable, Servlet, ServletConfig

    public class ConcatServlet

extends HttpServlet

Concatenation Servlet This servlet may be used to concatenate multiple resources into a single response. It is intended to be used to load multiple javascript or css files, but may be used for any content of the same mime type that can be meaningfully concatenated.

The servlet uses `RequestDispatcher.include(javax.servlet.ServletRequest, javax.servlet.ServletResponse)` to combine the requested content, so dynamically generated content may be combined (Eg engine.js for DWR).

The servlet uses parameter names of the query string as resource names relative to the context root. So these script tags:

      <script type="text/javascript" src="../js/behaviour.js"></script>
      <script type="text/javascript" src="../js/ajax.js&/chat/chat.js"></script>
      <script type="text/javascript" src="../chat/chat.js"></script>

can be replaced with the single tag (with the ConcatServlet mapped to /concat):

      <script type="text/javascript" src="../concat?/js/behaviour.js&/js/ajax.js&/chat/chat.js"></script>

The `ServletContext.getMimeType(String)` method is used to determine the mime type of each resource. If the types of all resources do not match, then a 415 UNSUPPORTED_MEDIA_TYPE error is returned.

If the init parameter "development" is set to "true" then the servlet will run in development mode and the content will be concatenated on every request. Otherwise the init time of the servlet is used as the lastModifiedTime of the combined content and If-Modified-Since requests are handled with 206 NOT Modified responses if appropriate. This means that when not in development mode, the servlet must be restarted before changed content will be served.

Author:
  gregw
See Also:
  Serialized Form

Constructor Summary
`ConcatServlet()`

Method Summary
`protected void` `doGet(HttpServletRequest req, HttpServletResponse resp)` Called by the server (via the `service` method) to allow a servlet to handle a GET request.
`protected long` `getLastModified(HttpServletRequest req)` Returns the time the `HttpServletRequest` object was last modified, in milliseconds since midnight January 1, 1970 GMT.
`void` `init()` A convenience method which can be overridden so that there's no need to call `super.init(config)`.

Methods inherited from class javax.servlet.http.HttpServlet
`doDelete, doHead, doOptions, doPost, doPut, doTrace, service, service`

Methods inherited from class javax.servlet.GenericServlet
`destroy, getInitParameter, getInitParameterNames, getServletConfig, getServletContext, getServletInfo, getServletName, init, log, log`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ConcatServlet

    public ConcatServlet()

Method Detail

### init

    public void init()
              throws ServletException

  Description copied from class: `GenericServlet`
  A convenience method which can be overridden so that there's no need to call `super.init(config)`.

  Instead of overriding `GenericServlet.init(ServletConfig)`, simply override this method and it will be called by `GenericServlet.init(ServletConfig config)`. The `ServletConfig` object can still be retrieved via `GenericServlet.getServletConfig()`.

  Overrides:
    `init` in class `GenericServlet`
  Throws:
    `ServletException` - if an exception occurs that interrupts the servlet's normal operation

### getLastModified

    protected long getLastModified(HttpServletRequest req)

  Description copied from class: `HttpServlet`
  Returns the time the `HttpServletRequest` object was last modified, in milliseconds since midnight January 1, 1970 GMT. If the time is unknown, this method returns a negative number (the default).

  Servlets that support HTTP GET requests and can quickly determine their last modification time should override this method. This makes browser and proxy caches work more effectively, reducing the load on server and network resources.

  Overrides:
    `getLastModified` in class `HttpServlet`
  Parameters:
    `req` - the `HttpServletRequest` object that is sent to the servlet
  Returns:
    a `long` integer specifying the time the `HttpServletRequest` object was last modified, in milliseconds since midnight, January 1, 1970 GMT, or -1 if the time is not known

### doGet

    protected void doGet(HttpServletRequest req,
                         HttpServletResponse resp)
                  throws ServletException,
                         IOException

  Description copied from class: `HttpServlet`
  Called by the server (via the `service` method) to allow a servlet to handle a GET request.

  Overriding this method to support a GET request also automatically supports an HTTP HEAD request. A HEAD request is a GET request that returns no body in the response, only the request header fields.

  When overriding this method, read the request data, write the response headers, get the response's writer or output stream object, and finally, write the response data. It's best to include content type and encoding. When using a `PrintWriter` object to return the response, set the content type before accessing the `PrintWriter` object.

  The servlet container must write the headers before committing the response, because in HTTP the headers must be sent before the response body.

  Where possible, set the Content-Length header (with the `ServletResponse.setContentLength(int)` method), to allow the servlet container to use a persistent connection to return its response to the client, improving performance. The content length is automatically set if the entire response fits inside the response buffer.

  When using HTTP 1.1 chunked encoding (which means that the response has a Transfer-Encoding header), do not set the Content-Length header.

  The GET method should be safe, that is, without any side effects for which users are held responsible. For example, most form queries have no side effects. If a client request is intended to change stored data, the request should use some other HTTP method.

  The GET method should also be idempotent, meaning that it can be safely repeated. Sometimes making a method safe also makes it idempotent. For example, repeating queries is both safe and idempotent, but buying a product online or modifying data is neither safe nor idempotent.

  If the request is incorrectly formatted, `doGet` returns an HTTP "Bad Request" message.

  Overrides:
    `doGet` in class `HttpServlet`
  Parameters:
    `req` - an `HttpServletRequest` object that contains the request the client has made of the servlet
    `resp` - an `HttpServletResponse` object that contains the response the servlet sends to the client
  Throws:
    `ServletException` - if the request for the GET could not be handled
    `IOException` - if an input or output error is detected when the servlet handles the GET request
  See Also:
    `ServletResponse.setContentType(java.lang.String)`

Copyright © 2008 Mort Bay Consulting. All Rights Reserved.